/*_############################################################################
  _## 
  _##  SNMP4J - ServerSocketEntry.java  
  _## 
  _##  Copyright (C) 2003-2018  Frank Fock and Jochen Katz (SNMP4J.org)
  _##  
  _##  Licensed under the Apache License, Version 2.0 (the "License");
  _##  you may not use this file except in compliance with the License.
  _##  You may obtain a copy of the License at
  _##  
  _##      http://www.apache.org/licenses/LICENSE-2.0
  _##  
  _##  Unless required by applicable law or agreed to in writing, software
  _##  distributed under the License is distributed on an "AS IS" BASIS,
  _##  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  _##  See the License for the specific language governing permissions and
  _##  limitations under the License.
  _##  
  _##########################################################################*/

package org.snmp4j.transport;

import org.snmp4j.smi.TcpAddress;

import java.net.Socket;
import java.nio.channels.ClosedChannelException;
import java.nio.channels.Selector;
import java.util.List;

public interface ServerSocketEntry {
    void addRegistration(Selector selector, int opKey)
        throws ClosedChannelException;

    void removeRegistration(Selector selector, int opKey)
            throws ClosedChannelException;

    boolean isRegistered(int opKey);

    long getLastUse();

    void used();

    Socket getSocket();

    TcpAddress getPeerAddress();

    void addMessage(byte[] message);

    byte[] nextMessage();

    boolean hasMessage();

    List<byte[]> getMessages();

    SocketTimeout getSocketTimeout();

    void setSocketTimeout(SocketTimeout socketTimeout);

    void closeSession();
}
